"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.default = _default;

var _includes = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/includes"));

var _path = _interopRequireDefault(require("path"));

const getNewPath = (value, filename) => {
  const dirname = _path.default.dirname(value);

  const basename = _path.default.basename(value);

  const newImportPath = [dirname, basename, basename].join('/');

  try {
    require.resolve(_path.default.resolve(_path.default.dirname(filename), newImportPath));

    return newImportPath;
  } catch (e) {
    return null;
  }
};

function _default({
  types: t
}) {
  return {
    visitor: {
      ImportDeclaration(p, state) {
        const {
          value
        } = p.node.source; // import xyz from <value>

        const {
          filename
        } = state.file.opts; // the file where this import statement resides
        // We only operate in "userland," skip node_modules.

        if (filename === null || filename === void 0 ? void 0 : (0, _includes.default)(filename).call(filename, '/node_modules/')) return; // We only need this plugin in the module could not be found.

        try {
          require.resolve(value);

          return; // ABORT
        } catch {// CONTINUE...
        }

        const newPath = getNewPath(value, filename);
        if (!newPath) return;
        const newSource = t.stringLiteral(value.replace(value, newPath));
        p.node.source = newSource;
      },

      ExportDeclaration(p, state) {
        var _p$node;

        // @ts-expect-error - TypeDef must be outdated.
        if (!(p === null || p === void 0 ? void 0 : (_p$node = p.node) === null || _p$node === void 0 ? void 0 : _p$node.source)) {
          return;
        } // @ts-expect-error - TypeDef must be outdated.


        const {
          value
        } = p.node.source;
        const {
          filename
        } = state.file.opts; // We only operate in "userland," skip node_modules.

        if (filename === null || filename === void 0 ? void 0 : (0, _includes.default)(filename).call(filename, '/node_modules/')) return; // We only need this plugin in the module could not be found.

        try {
          require.resolve(value);

          return; // ABORT
        } catch {// CONTINUE...
        }

        const newPath = getNewPath(value, filename);
        if (!newPath) return;
        const newSource = t.stringLiteral(value.replace(value, newPath)); // @ts-expect-error - TypeDef must be outdated.

        p.node.source = newSource;
      }

    }
  };
}