"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs3/helpers/interopRequireDefault");

var _Object$defineProperty = require("@babel/runtime-corejs3/core-js/object/define-property");

_Object$defineProperty(exports, "__esModule", {
  value: true
});

exports.StorybookProvider = void 0;

var _keys = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/keys"));

var _forEach = _interopRequireDefault(require("@babel/runtime-corejs3/core-js/instance/for-each"));

var _react = require("react");

var _testing = require("@redwoodjs/testing");

const StorybookProvider = ({
  storyFn,
  id
}) => {
  const [loading, setLoading] = (0, _react.useState)(true);
  (0, _react.useEffect)(() => {
    const init = async () => {
      var _context;

      // Import all the `*.mock.*` files.
      const reqs = require.context('~__REDWOOD__USER_WEB_SRC', true, /.+(mock).(js|ts)$/);

      (0, _forEach.default)(_context = (0, _keys.default)(reqs).call(reqs)).call(_context, r => {
        reqs(r);
      });
      await (0, _testing.startMSW)();
      (0, _testing.setupRequestHandlers)();
      setLoading(false);
    };

    init();
  }, [id]);

  if (loading) {
    return null;
  }

  return /*#__PURE__*/React.createElement(_testing.MockProviders, null, storyFn());
};

exports.StorybookProvider = StorybookProvider;